
function [w, b] = svm_train(trainFile)
%for automated characterization of this algo, I made it a function
%[spmatrix, tokenlist, trainCategory] = readMatrix('MATRIX.TRAIN.1400');
[spmatrix, tokenlist, trainCategory] = readMatrix(trainFile);

trainMatrix = full(spmatrix);
numTrainDocs = size(trainMatrix, 1);
numTokens = size(trainMatrix, 2);

% trainMatrix is now a (numTrainDocs x numTokens) matrix.
% Each row represents a unique document (email).
% The j-th column of the row $i$ represents the number of times the j-th
% token appeared in email $i$. 

% tokenlist is a long string containing the list of all tokens (words).
% These tokens are easily known by position in the file TOKENS_LIST

% trainCategory is a (numTrainDocs x 1) vector containing the true 
% classifications for the documents just read in. The i-th entry gives the 
% correct class for the i-th email (which corresponds to the i-th row in 
% the document word matrix).

% Spam documents are indicated as class 1, and non-spam as class 0.
% Note that for the SVM, you would want to convert these to +1 and -1.


% YOUR CODE HERE
% Peter Harrington HW #2 3d

%convert 0's in the trainMatrix to -1
for i=1:numTrainDocs
    if(trainCategory(i) == 0)
        trainCategory(i)= -1;
    end
end
C = 1;
max_passes = 20;
tol = 0.01;
Y = trainCategory';

%call the SMO algo
[b, alphas] = smo_train(trainMatrix, Y, C, tol, max_passes);      

% compute the weights (assuming a linear kernel)
w = zeros(numTokens,1);
for i=1:numTrainDocs
  w = w + alphas(i)*Y(i)*trainMatrix(i,:)';
end


